"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var execa = require("execa");
var fs = require("fs");
var inquirer = require("inquirer");
var kleur = require("kleur");
var mkdirp = require("mkdirp");
var showBanner = require("node-banner");
var ora = require("ora");
// Setting path to the template files.
var templatePath = __dirname + "/../templates";
/**
 * @param {String} projectName - Name of the project as supplied by the user
 * @returns {Promise<void>}
 */
exports.default = (function (projectName) { return __awaiter(_this, void 0, void 0, function () {
    var args, frameworkOfChoice, template, spinner, pkgJson, webpackConfig;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, showBanner("Scaffold Static", "scaffolding utility for vanilla-js")];
            case 1:
                _a.sent();
                args = process.argv.slice(3);
                // Validating if multiple arguments are supplied or not.
                if (args.length > 1) {
                    console.log(kleur
                        .red()
                        .bold(" Kindly provide only one argument as the project name!!"));
                    process.exit(1);
                }
                if (fs.existsSync(projectName)) {
                    console.log(kleur.red().bold(" " + projectName + " already exists within the path!!"));
                    process.exit(1);
                }
                return [4 /*yield*/, inquirer.prompt([
                        {
                            name: "frameworkOfChoice",
                            type: "list",
                            message: "Please choose the CSS framework of your choice",
                            choices: [
                                "Bootstrap-3",
                                "Bootstrap-4",
                                "Materialize",
                                "Foundation",
                                "Semantic-UI",
                                "Bulma",
                                "None"
                            ]
                        }
                    ])];
            case 2:
                frameworkOfChoice = (_a.sent()).frameworkOfChoice;
                execa.commandSync("mkdir " + projectName);
                mkdirp.sync(projectName + "/css");
                mkdirp.sync(projectName + "/js");
                fs.writeFileSync(projectName + "/css/style.css", "/* Write your rulesets here! */");
                fs.writeFileSync(projectName + "/js/main.js", "require('../css/style.css');");
                template = fs.readFileSync(templatePath + "/" + frameworkOfChoice.toLowerCase() + "/index.html", "utf-8");
                fs.writeFileSync(projectName + "/index.html", template);
                // Navigate to the respective directory to execute shell commands
                process.chdir(projectName);
                spinner = ora("Getting things ready").start();
                // Installing required dependencies
                spinner.text = "Installing dependencies";
                return [4 /*yield*/, execa.command("npm install --save-dev webpack webpack-cli webpack-dev-server css-loader style-loader html-webpack-plugin")];
            case 3:
                _a.sent();
                // Generate package.json template
                return [4 /*yield*/, execa.command("npm init -y")];
            case 4:
                // Generate package.json template
                _a.sent();
                pkgJson = JSON.parse(fs.readFileSync("./package.json").toString());
                // Add build and serve scripts
                pkgJson = __assign({}, pkgJson, { name: projectName, scripts: __assign({}, pkgJson.scripts, { build: "webpack", serve: "webpack-dev-server --open" }) });
                fs.writeFileSync("./package.json", JSON.stringify(pkgJson));
                webpackConfig = fs.readFileSync(templatePath + "/webpack.config.js");
                // Write back the config
                fs.writeFileSync("webpack.config.js", webpackConfig);
                // Show success spinner
                spinner.succeed("You're all set");
                // Logs
                console.log();
                console.log(kleur.green().bold("Please follow these instructions:- "));
                console.log(kleur.cyan().bold("cd " + projectName + " && npm run serve"));
                return [2 /*return*/];
        }
    });
}); });
